#include <windows.h>
#include "winapp.h"

int WinApp::Init(char* szAppName, WNDPROC WndProc, HINSTANCE NewhInst, LPSTR lpszNewArgs, int nNewCmdShow )
{
// Define Window Class
	WndClass.hInstance = hInst;
	WndClass.lpszClassName = szAppName;
	WndClass.lpfnWndProc = WndProc;
	WndClass.style = 0;	// No special styles

	// Set resources for the program: Icon, Cursor, Menu (we have none), and background
	WndClass.hIcon = LoadIcon( NULL, IDI_APPLICATION );
	WndClass.hCursor = LoadCursor( NULL, IDC_ARROW );
	WndClass.lpszMenuName = NULL;
	WndClass.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );

	WndClass.cbClsExtra = 0; // 'Extra' information about this window,
	WndClass.cbWndExtra = 0; // our program has none.

	// Register the class (this includes the 'WndProc')
	PreRegisterClass( WndClass );
	if( !RegisterClass( &WndClass ) )
	{
		MessageBox( NULL, "Error registering class", NULL, MB_ICONEXCLAMATION|MB_OK );
		return( 0 );
	}

	// Create the window, which will be our main window
	hWnd = CreateWindow( szAppName, "Hello", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
		HWND_DESKTOP, NULL, hInst, NULL );

	if( !hWnd )
	{
		MessageBox( NULL, "Error creating window", NULL, MB_ICONEXCLAMATION|MB_OK );
		return( 0 );
	}
}

virtual void WinApp::MessageLoop()
{
	while( GetMessage( &Msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &Msg );
		DispatchMessage( &Msg );
	}
}

virtual static LRESULT CALLBACK WinApp::WndProc( HWND, UINT, WPARAM, LPARAM )
{
	switch( Message )
	{
		case WM_PAINT:
			HDC DC;
			PAINTSTRUCT PaintStruct;
			DC = BeginPaint( hWnd, &PaintStruct );
			OnDraw( hWnd, DC, PaintStruct );
			EndPaint( hWnd, &PaintStruct );
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			// Any unhandled messages are passed onto to the default handler.
			return( DefWindowProc( hWnd, Message, wParam, lParam ) );
	}
}
		
